/*------------------------------------------------*/
/* c35/zapis1.c                                   */
#define _CRT_NONSTDC_NO_DEPRECATE
#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <errno.h>
#ifdef unix
#include <unistd.h>
#else
#include <io.h>
#endif

#define POCET_CYKLU 1000000u

#ifdef __unix__
#define OPEN open("jmeno.txt",O_RDWR|O_CREAT|O_TRUNC,\
		S_IRUSR|S_IWUSR|S_IRGRP|S_IROTH)
#else
#define OPEN open("jmeno.txt",O_RDWR|O_CREAT|O_TRUNC|O_TEXT)
#endif


int main(void)
{
    int id;
    size_t i;
    char SNO[] = "Soubor nelze otevrit (uz existuje?)\n";
    char TEXT1[] = "Tenhle text budeme zapisovat do souboru\n";
    char TEXT2[] = "-------------- prepsano ---------------\n";

    if ((id = OPEN) <= 0) {
	/* fprintf by bylo vhodnejsi, ale nemohl jsem si to odpustit :-} */
	write(fileno(stderr), SNO, strlen(SNO));
	perror(NULL);
	exit(1);
    }

    for (i = 0; i < POCET_CYKLU * 10u; i++) {
	if (write(id, TEXT1, strlen(TEXT1)) == -1) {
	    fprintf(stderr, "Data nelze zapisovat");
		perror(NULL);
	    exit(1);
	}
    }


    lseek(id, 0, SEEK_SET);
    for (i = 0L; i < POCET_CYKLU; i++) {
	if (write(id, TEXT2, strlen(TEXT2)) == -1) {
	    fprintf(stderr, "Data nelze zapisovat");
		perror(NULL);
	    exit(1);
	}
#ifdef __unix__
#define clrf 0
#else
#define clrf 1
#endif
	lseek(id, (strlen(TEXT1) + clrf) * 9, SEEK_CUR);
#undef clrf
    }

    close(id);	/* spravne by bylo kontrolovat navratovou hodnotu */
    return 0;
}

/*------------------------------------------------*/
